/* NsmConText: Nvu Site Manager ConText extension
 *
 * This patch of the site manager opens non-html files with external editors.
 * It also integrates a Launchy menu (http://gemal.dk/mozilla/launchy.html) into N|vu's site manager.
 *
 * My main goals are:
 *    > preview html files in Firefox, IE, Opera, ...
 *    > edit code files (js, php, asp...) with an appropriate editor
 *    > html-tidy files ("pretty-print" the code)
 *    > share launchy.xml with Firefox
 * 
 * For now, there are only 3 fixed file categories:
 *    > images files (as defined in the 'IsHiddenByFilter' function)
 *    > css stylesheets (to open with cascades, not working yet)
 *    > non-html, non-image files (to open with a text editor)
 * An option box allows to choose a editor for each category.
 *
 * TODO (= planned for sometime):
 *    > modify the option box to let the user add categories (id + name + regexp + command line)
 *    > auto reload html documents after editing html or css files with external apps
 *    > open CSS files with CaScadeS
 *    > "FTP sync" menu entry (I really miss that feature!)
 *    > XUL interface for ImageMagick (wouldn't that be neat?!?)
 *
 * Known bugs (= should be corrected soon):
 *    > Launchy integration is limited (you can't pass args, MIME type is ignored, ...)
 *    > ugly code (no 'locales' yet for instance...)
 *    > this is my first XUL hack... there might be lots of bugs :-(
 */

//
// Nsm dialogs & prefs
const NvuPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var NvuPublishPrefs = NvuPrefs.getBranch("editor.publish.site_data.");
var NsmPrefs     = NvuPrefs.getBranch("extensions.nsmcontext.sitemanager.");
var NsmToolbars  = NvuPrefs.getBranch("extensions.nsmcontext.toolbars.");
var NsmBundle    = NvuPrefs.getBranch("extensions.nsmcontext.bundle.");
var NsmApps;

// NsmConText.xul (prefs window)
function openPropDialog() {
	var g = GetDocumentUrl();
	alert("url: "+ g + "\ntitle: " + window.top.title);
  //~ try {
	//~ var aDOMHTMLDoc = GetCurrentEditor().document.QueryInterface(Components.interfaces.nsIDOMHTMLDocument);
	//~ alert("url: "+ aDOMHTMLDoc.URL);
  //~ }
  //~ catch (e) {};

//~ window.top.addEventListener("load",tabClicking.onLoad,false);
//~ tabClicking.onLoad();
	
	//~ var args = new Array();
	//~ args[0] = "test";
	//~ args[1] = "gInitialSiteName";
	//~ args[2] = "gReturnData";
  //~ openDialog("chrome://editor/content/EditorPublish.xul","Publish","dialog=yes", args);
  //~ openDialog("chrome://editor/content/EditorPublish.xul","Publish","dialog=yes", "", "gInitialSiteName", "gReturnData");
	//~ var publishData = CreatePublishDataFromUrl(docUrl);
	//~ window.openDialog("chrome://editor/content/EditorPublish.xul","_blank", 
                        //~ "chrome,close,titlebar,modal", docUrl, "Leo", publishData);
        var item = GetNsmItem();
	var siteItem = GetNsmSite();
	var username = {value:""};
	var size = item.size + " bytes";
	if (item.size >= 1024*1024)
		size = Math.round(10 * item.size / (1024*1024)) /10 + " MB (" + size + ")";
	else if (item.size >= 1024)
		size = Math.round(10 * item.size / 1024) /10 + " KB (" + size + ")";
	//~ var type = GetItemType(item);
	//~ alert (item.url.replace(siteItem.url, "")
	var msg = ( item.url.replace(siteItem.url, "")
		+ "\n" + (item.isContainer ? "Folder" : GetItemType(item) + ", " + size)
		+ "\nlast modified: " + item.lastModified
		+ "\n\nSite : " + siteItem.name
		+ "\n" + siteItem.browseUrl
		+ "\n" + StripUsernamePassword(siteItem.url, username).replace("%2E", ".")
	);
	AlertWithTitle (item.url.replace(siteItem.url, ""), msg);
/* local Dir parser	
function GetLocalFileFromURLSpec(url)
{
  return GetFileFromURLSpec(url).QueryInterface(nsILocalFile);
}

function GetFileFromURLSpec(url)
{
  var fileHandler = GetFileProtocolHandler();
  return fileHandler.getFileFromURLSpec(url);
}

function OpenLocalDirectory(aUrl, aRQdata)
{
  EnableAllUI(false);

  var localFile = GetLocalFileFromURLSpec(aUrl);

  var dirEntries = localFile.directoryEntries;
  while (dirEntries.hasMoreElements())
  {
    var fileEntry = dirEntries.getNext().QueryInterface(Components.interfaces.nsIFile);
    AddLocalDirSubdirs(aUrl, fileEntry, aRQdata);
  }

  var i, l = gItemsArray.length;
  for (i = aRQdata.row; i < l; i++)
    gItemsArray[i].realIndex = i;
  gDialog.SiteTree.treeBoxObject.invalidateRow(aRQdata.parentRow);            

  EnableAllUI(true);
}
*/
	var localFile = GetLocalFileFromURLSpec(item.url);
	AlertWithTitle ("nsIFile", localFile.size + "\n" + localFile.lastModified);
/* 	
	var dirEntries = localFile.directoryEntries;
	while (dirEntries.hasMoreElements())
	{
		var fileEntry = dirEntries.getNext().QueryInterface(Components.interfaces.nsIFile);
		AlertWithTitle ("nsIFile", fileEntry.location + "\n" + fileEntry.size + "\n" + fileEntry.lastModified);
		//~ AddLocalDirSubdirs(aUrl, fileEntry, aRQdata);
	}
 */	
}

function openCascadesDialog() {
  // this function doesn't work yet (never called anyway)
  //~ var doc = new ??? 
  //~ alert("CaScadeS");
  //~ window.openDialog("chrome://cascades/content/EdCssProps.xul","_blank", "chrome,close,modal,titlebar");
  currentEditor = GetCurrentEditor();
  documentUrl = GetDocumentUrl();
  alert("url: " + documentUrl);
  window.openDialog("chrome://nsmcontext/content/NsmCssProps.xul","", "chrome,close,modal,titlebar");
  window._content.focus();
  //~ alert("Done");
}

function openPrefDialog() {
  openDialog("chrome://nsmcontext/content/NsmConText.xul","Preferences","dialog=yes");
}
function openLaunchyDialog() {
  openDialog("chrome://launchy/content/options.xul","Launchy","dialog=yes");
}
function openLaunchyXml() {
	var AppPath = NsmPrefs.getCharPref("extEditor");
	NsmLaunchExe(AppPath, LaunchyContext.xmlfile);
}
function getNsmBundle(s) {
	try {
		var b = NsmBundle.getCharPref(s);
		//~ var b = "&NsmConText-" + s + ".label;";
	} catch(ex) {
		b = s;
		//~ alert("Unable to get bundle <" + s + "> from <" + d + "> due to:\n" + ex);
	}
	return b;
}
function getNsmPrefs() {
	document.getElementById("NsmDefaultEditor-img").value = NsmPrefs.getCharPref("imgEditor");
	document.getElementById("NsmDefaultEditor-css").value = NsmPrefs.getCharPref("cssEditor");
	document.getElementById("NsmDefaultEditor-ext").value = NsmPrefs.getCharPref("extEditor");
	
	document.getElementById("NsmHtmlShowBrowsers").checked = NsmPrefs.getBoolPref("ShowBrowsers");
	document.getElementById("NsmHtmlShowEditors").checked  = NsmPrefs.getBoolPref("ShowEditors");
	
	document.getElementById("StructToolbar-ShowId").checked    = NsmToolbars.getBoolPref("ShowId");
	document.getElementById("StructToolbar-ShowClass").checked = NsmToolbars.getBoolPref("ShowClass");
	document.getElementById("StructToolbar-ShowAttrs").checked = NsmToolbars.getBoolPref("ShowAttrs");
}

function setNsmPrefs() {
	NsmPrefs.setCharPref("imgEditor", document.getElementById("NsmDefaultEditor-img").value);
	NsmPrefs.setCharPref("cssEditor", document.getElementById("NsmDefaultEditor-css").value);
	NsmPrefs.setCharPref("extEditor", document.getElementById("NsmDefaultEditor-ext").value);
	launchyContext.doInit();
	
	NsmPrefs.setBoolPref("ShowBrowsers", document.getElementById("NsmHtmlShowBrowsers").checked);
	NsmPrefs.setBoolPref("ShowEditors",  document.getElementById("NsmHtmlShowEditors").checked);
	
	NsmToolbars.setBoolPref("ShowId",    document.getElementById("StructToolbar-ShowId").checked);
	NsmToolbars.setBoolPref("ShowClass", document.getElementById("StructToolbar-ShowClass").checked);
	NsmToolbars.setBoolPref("ShowAttrs", document.getElementById("StructToolbar-ShowAttrs").checked);
	UpdateStructToolbar;
}

function addNsmPrefItems(menuid, type, pref) {
	NsmClearMenu(menuid);
	var path;
	var value;
	for (var i = 0; LaunchyContext.apps.length > i; i++)
		if (LaunchyContext.apps[i].type == type) {
			path = LaunchyContext.apps[i].exe.replace(/\\/g, "\\\\");
			value = "document.getElementById('" + pref + "').value = '" + path +"';";
			NsmAppendLaunchyItem(menuid, i, value);
		}
}
/*
var NsmBundle = null;
function getNsmBundle(s) {
	var d = "bundle_nsmcontext";
	s = "NsmConText-" + s;
	try {
		//~ var b = document.getElementById(d).getString(s);
		var b = NsmBundle.getString(s);
	} catch(ex) {
		//~ alert("Unable to get bundle <" + s + "> from <" + d + "> due to:\n" + ex);
	}
	//~ if (!b)
		//~ alert("Unable to get bundle <" + s + "> from <" + d + ">");
	return b;
}
*/
//
// Modified 'IsHiddenByFilter' function (override that in 'comm.jar/editor/content/sitemanager.js')
function IsHiddenByFilter(filter, fileName) {
	if (filter == "html")
		var re = /\.html?$|\.shtml?$/i ;
	else if (filter == "images")
		re = /\.gif$|\.png$|\.jpg$|\.jpeg$|\.ico$/i ;
	else if (filter == "media")
		re = /\.wav$|\.wma$|\.aiff$|\.mp3$|\.ogg$|\.mpg$|\.mpeg$|\.avi$|\.wmv$|\.ogm$/i ;
	else if (filter == "css")
		re = /\.css$/i ;
	else if (filter == "cgi")
		re = /\.php$|\.asp$|\.jsp$|\.pl$/i ;
	else // "all" or unknown filter
		return false;
	return !re.test(fileName);
}
//
// Modified 'UpdateStructToolbar' function (override that in 'comm.jar/editor/content/editor.js')
// should probably be in another extension...
function newStructToolbarButton(tag, attr) {
	var ttip, tagId, attrName, attrValue, attref;
	
	button = document.createElementNS(XUL_NS, "toolbarbutton");
	button.setAttribute("value", tag);
	
	// get user prefs
	var ShowId    = false;
	var ShowClass = false;
	var ShowAttrs = false;
	try {
		ShowId    = NsmToolbars.getBoolPref("ShowId");
		ShowClass = NsmToolbars.getBoolPref("ShowClass");
		ShowAttrs = NsmToolbars.getBoolPref("ShowAttrs");
	} catch (e) {};
	
	// Let's add "id" and "class" attributes in the label
	// and other attributes in the tooltip
	ttip = "";
	tagId = "";
	for (attref = 0; attref < attr.length; attref++) {
		attrName  = attr[attref].nodeName;
		attrValue = attr[attref].value;
		if (ShowId && (attrName == "id"))
			tagId = ' id="' + attrValue + '"' + tagId;
		else if (ShowClass && (attrName == "class"))
			tagId += ' class="' + attrValue + '"';
		else if (ShowAttrs)
			ttip += attrName + '="' + attrValue + '" ';
	}
	button.setAttribute("label", "<" + tag + tagId + ">");
	
	if (ttip != "")
		button.setAttribute("tooltiptext", ttip);
	
	return button;
}
function UpdateStructToolbar() {
  var editor = GetCurrentEditor();
  if (!editor) return;

  var mixed = GetSelectionContainer();
  if (!mixed) return;
  var element = mixed.node;
  var oneElementSelected = mixed.oneElementSelected;

  if (!element) return;

  NotifyProcessors(kProcessorsWhenSelectionChanges, element);

  if (element == gLastFocusNode &&
      oneElementSelected == gLastFocusNodeWasSelected)
    return;

  gLastFocusNode = element;
  gLastFocusNodeWasSelected = mixed.oneElementSelected;

  var toolbar = document.getElementById("structToolbar");
  if (!toolbar) return;
  var childNodes = toolbar.childNodes;
  var childNodesLength = childNodes.length;
  // We need to leave the <label> to flex the buttons to the left
  // so, don't remove the last child at position length - 1
  for (var i = childNodesLength - 2; i >= 0; i--) {
    toolbar.removeChild(childNodes.item(i));
  }

  toolbar.removeAttribute("label");

  if ( IsInHTMLSourceMode() ) {
    // we have destroyed the contents of the status bar and are
    // about to recreate it ; but we don't want to do that in
    // Source mode
    return;
  }

  // XXXXXX
  if (true)
  {
    UpdateRulers(element);
    if (!gScrollListener)
      gScrollListener        = GetCurrentEditor().document.addEventListener("scroll", UpdateRulerRequestListener, false);
    if (!gResizeListener)
      gResizeListener        = window.addEventListener("resize", UpdateRulerRequestListener, false);
    if (!gEditorUpdatedListener)
      gEditorUpdatedListener = GetCurrentEditor().document.addEventListener("editorViewUpdated", UpdateRulerRequestListener, false);
  }

  var bodyElement = GetBodyElement();
  var isFocusNode = true;
  var tmp;
  var tag = gLastFocusNode.nodeName.toLowerCase();

  toolbar.firstChild.removeAttribute("style");
  var button;
  do {
    tag = element.nodeName.toLowerCase();

    // <Kaze>
    //~ button = document.createElementNS(XUL_NS, "toolbarbutton");
    //~ button.setAttribute("label",   "<" + tag + ">");
    //~ button.setAttribute("value",   tag);
    // Let's add "id" and "class" attributes in the tag
    // and other attributes in the tooltip
    button = newStructToolbarButton(tag, element.attributes);
    // </Kaze>
    button.setAttribute("context", "structToolbarContext");
    button.className = "struct-button";

    toolbar.insertBefore(button, toolbar.firstChild);

    button.addEventListener("command", newCommandListener(element), false);
    button.addEventListener("contextmenu", newContextmenuListener(button, element), false);

    if (isFocusNode && oneElementSelected) {
      button.setAttribute("checked", "true");
      isFocusNode = false;
    }

    tmp = element;
    element = element.parentNode;

  } while (tmp != bodyElement);

}
//
// this should be in a [NsmConTextMenu] class definition
function NsmClearMenu(menuid) {
	var children = menuid.childNodes;
	for (var j = children.length-1; j >= 0; j--)
		menuid.removeChild(children[j]);
/* 		
	var menuitem = document.createElement("menuitem");
	menuitem.setAttribute("label", "NsmConText");
	menuitem.setAttribute("disabled", "true");
	menuid.appendChild(menuitem);
	NsmAppendMenuSeparator(menuid);
 */	
}
function NsmAppendMenuItem(menuid, label, command) {
	var menuitem = document.createElement("menuitem");
	menuitem.setAttribute("label", label);
	menuitem.setAttribute("oncommand", command);
	menuid.appendChild(menuitem);
}
function NsmAppendMenuSeparator(menuid) {
	var menuseparator = document.createElement("menuseparator");
	menuid.appendChild(menuseparator);
}
function NsmAppendLaunchyItem(menuid, AppRef, command) {
	var menuitem = document.createElement("menuitem");	
	menuitem.setAttribute("label", LaunchyContext.apps[AppRef].name);
	//~ menuitem.setAttribute("label", "Ouvrir avec " + LaunchyContext.apps[AppRef].name);
	menuitem.setAttribute("oncommand", command);
	if (typeof(LaunchyContext.showfileicons) != "undefined" && LaunchyContext.showfileicons) {
		menuitem.setAttribute("class", "menuitem-iconic");
		menuitem.setAttribute("image", "moz-icon:file://" + LaunchyContext.apps[AppRef].exe + "?size=16");
	}
	menuid.appendChild(menuitem);
}
function NsmAppendLaunchyItems(menuid, type, command) {
	if (!command)
		command = "NsmLaunch(#)";
	for (var i = 0; LaunchyContext.apps.length > i; i++)
		if (LaunchyContext.apps[i].type == type)
			NsmAppendLaunchyItem(menuid, i, command.replace("#", i));
}
function NsmAppendSignature(menuid) {
	NsmAppendMenuItem(menuid, "NsmConText...", "openPrefDialog()");
}
/* function NsmAppendMenuPopup(menuid, label, command) {
	//~ var menuitem = document.createElement("menuitem");
	var menu = document.createElement("menu");
	menu.setAttribute("label", label);
	menu.setAttribute("id", "NsmMenu"+label);
	
	var menupopup = document.createElement("menupopup");
	menupopup.setAttribute("id", "NsmPopup"+label);
	//~ menupopup.setAttribute("onpopupshowing", command);	
	if (label == "Ouvrir") {
		//~ NsmConTextOpen(menupopup);
		NsmAppendMenuItem(menupopup, "Nouvel onglet", "NsmEdit(true,'')");
		NsmAppendMenuItem(menupopup, "Nouvelle fentre", "NsmEdit(false,'')");
		NsmAppendMenuSeparator(menupopup);
		//~ NsmAppendLaunchyItems(menupopup, 7);
	} else if (label == "Navigateur") {
		//~ NsmConTextPreview(menupopup);
		NsmAppendMenuItem(menupopup, "Navigateur par dfaut", "NsmPreviewAppRef=-1; loadExternalURL()");
		NsmAppendMenuSeparator(menupopup);
		//~ NsmAppendLaunchyItems(menupopup, 1);
	}
	menuid.appendChild(menu);
	menu.appendChild(menupopup);
}
 */
function NsmAppendBrowsers(menuid, url, show) {
	// Experimental: replace ftp://mysite by http://mysite for browser previews
	// Works with HTML and PHP, but only when called from the  Site Manager
	if (!url) try {
		url = GetNsmItem().url; 
		url = urlToHttp(url);
	} catch (e) {};
	
	// show browsers if the pref requests it
	if (!show) try {
		show = NsmPrefs.getBoolPref("ShowBrowsers");
	} catch (e) {};
	if (show) {
		NsmAppendLaunchyItems(menuid, 1, "NsmLaunch(#, '" + url + "');");
		NsmAppendMenuSeparator(menuid);
	}
}
function NsmAppendEditors(menuid, url, show) {
	// show editors on local files, if the pref requests it
	if (!show) try {
		show = NsmPrefs.getBoolPref("Editors");
	} catch (e) {};
	if (show) {
		NsmAppendLaunchyItems(menuid, 7, "NsmLaunch(#, '" + url + "');");
		NsmAppendMenuSeparator(menuid);
	}
	return;
}
function NsmAppendConText(menuid, url) {
}

//
// Using some modified parts of Launchy FileIO class to launch apps 
var NsmFileIO = {

	localfileCID : '@mozilla.org/file/local;1',
	localfileIID : Components.interfaces.nsILocalFile,

	urlCID : '@mozilla.org/network/standard-url;1',
	urlIID : Components.interfaces.nsIURL,
	
	processCID : '@mozilla.org/process/util;1',
	processIID : Components.interfaces.nsIProcess,
	
	urlToPath : function(data) {
		try {
			const hasUnescape = (typeof(unescape)=="function");
			var uri = Components.classes[this.urlCID].createInstance(this.urlIID);
			uri.spec = data;
			var file = Components.classes[this.localfileCID].createInstance(this.localfileIID);
			try {
				file.initWithPath(uri.path);
				data = hasUnescape ? unescape(file.path) : file.path;
			} catch (e) {
				// foobar!
			}
			try {
				file.initWithPath(uri.path.replace(/^\//,"").replace(/\//g,"\\"));
				data = hasUnescape ? unescape(file.path) : file.path;
			} catch (e) {
				// foobar!
			}
		}
		catch(e) {
			// foobar!
		}
		return data;
	},

	newLocalFile : function(file) {
		// Kaze: this is a new function (not in Launchy.xpi)
		// more info about processes: http://www.xulplanet.com/references/xpcomref/comps/c_processutil1.html
		try {
			var nsFile = Components.classes[this.localfileCID].createInstance(this.localfileIID);
			nsFile.initWithPath(file);
		} catch(e) {
			// foobar!
		}
		
//~ var msg = "This file is getting edited.";
//~ try {
	//~ msg = "This file is getting edited."
		//~ + "\n path = " + nsFile.path
		//~ + "\n" + nsFile.fileSize
		//~ + "\n" + nsFile.lastModifiedTime;
//~ } catch (e) {
//~ }
//~ AlertWithTitle("NsmConText", msg);
		
		return nsFile;
	},
	
	newProcess : function(nsFile) {
		// Kaze: this is a new function (not in Launchy.xpi)
		// more info about processes: http://www.xulplanet.com/references/xpcomref/comps/c_processutil1.html
		
		var process = null;
		if (nsFile.isFile() && nsFile.isExecutable()) try {
			process = Components.classes[this.processCID].createInstance(this.processIID);
			process.init(nsFile);
		} catch(e) {
			// foobar!
		}
		return process;
	},
	
	run : function(file, data) {
		var len = 0;
		if (data)
			len = data.length;
		else
			data = null;
/*		try {
			var len = 0;
			if (data)
				len = data.length;
			else
				data = null;

			var lfile = Components.classes[this.localfileCID].createInstance(this.localfileIID);
			lfile.initWithPath(file);
			
			if (lfile.isFile() && lfile.isExecutable()) {
				try {
					var process = Components.classes[this.processCID].createInstance(this.processIID);
					process.init(lfile);
					data = process.run(false, data, len);
					//~ process.kill();
					//~ process.abort();
					//~ process.stop();
				} catch (e) {
					// foobar!
				}
			}
		}
*/

		try {
			var nsFile = this.newLocalFile(file);
			var process = this.newProcess(nsFile);
			data = process.run(false, data, len);
NsmExternalEditorProcess = process;
		}
		catch(e) {
			// foobar!
		}
 		return data;
	}
}
function NsmLaunchExe(AppPath, FileURL) {
	var success = 1;
	
	// only works on local files !
	//~ if (GetScheme(FileURL) == "file") try {
	try {
		var args = new Array();
		args[0] = NsmFileIO.urlToPath(FileURL);
		NsmFileIO.run(AppPath, args);
		//~ DEBUG ( "app launched" );
	} catch (e) {
		success = 0;
	};
	return success;
}
function NsmLaunch(LaunchyAppRef, FileURL) {
	var url;
	if (FileURL)
		url = FileURL;
	else {
		url = GetNsmItem().url;
		//Experimental: replace ftp://mysite by http://mysite for browser previews
		if (LaunchyContext.apps[LaunchyAppRef].type == 1) {
			url = urlToHttp(url);
			//~ var siteItem = GetNsmSite();
			//~ if (siteItem.browseUrl != "http://")
				//~ url = url.replace(siteItem.url, siteItem.browseUrl.replace(/\/$/, ""));
		}
	}	
	
	var success = 1;
	var args = new Array();
	if (LaunchyContext.apps[LaunchyAppRef].args.length > 0)
		args[0] = LaunchyContext.apps[LaunchyAppRef].args;
	//~ args[args.length] = NsmFileIO.urlToPath(FileURL);
	//~ if (GetScheme(url) == "file")
	if (url.substring(0, 4) == "file")
		args[args.length] = NsmFileIO.urlToPath(url);
	else
		args[args.length] = url.replace("%2E", ".");
	
	// only works on local files !
	try {
		NsmFileIO.run(LaunchyContext.apps[LaunchyAppRef].exe, args);
		DEBUG ( "app launched" );
	} catch (e) {
		success = 0;
	};
	return success;
}
/* function NsmLaunchAndNotify(LaunchyAppRef, url) {
	url = (url) ? url : GetDocumentUrl();
	nsSaveCommand.doCommand();
	NsmExternalEditorLaunched = true;
	var ret = NsmLaunch(LaunchyAppRef, url);
	//~ alert ("click to reload the file");
	//~ CancelHTMLSource();
	//~ EditorLoadUrl(GetDocumentUrl());
	return ret;
}
 */
function urlToHttp(url) {
	var http;
	var siteItem = GetNsmSite(url);
	url = (url) ? url : GetNsmItem().url;
	
	if (siteItem.browseUrl != "http://")
		http = url.replace(siteItem.url, siteItem.browseUrl.replace(/\/$/, ""));
	else
		http = url;
	return http;
}
//
// sandbox
var tabClicking = {
  version: '0.5',
  tcPrefs: null,
  toBeClonedBrowser: null,
	selectedTab: null,
	openedBrowser: null,
	openedWindow: null,
	clonedHistory: null,
	scrollPosX: 0,
	scrollPosY: 0,
	zoomFactor: 100,

  funcs: {
    onTabClick: null,
    onTabBarDblClick: null
  },

  prefs: {
    action: 0,
    selectTab: true,
    tablib: false
  },

    /* replace tab click functions with new functions on browser load */
  onLoad: function() {
    tabClicking.tcPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
    tabClicking.funcs.onTabClick = getBrowser().onTabClick;
    tabClicking.funcs.onTabBarDblClick = getBrowser().onTabBarDblClick;
    getBrowser().onTabClick = tabClicking.onTabClick;
    getBrowser().mTabContainer.setAttribute('ondblclick', 'tabClicking.onTabBarDblClick(event);');
    //~ tabClicking.tcPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
    //~ tabClicking.funcs.onTabClick = GetCurrentEditor().onTabClick;
    //~ tabClicking.funcs.onTabBarDblClick = GetCurrentEditor().onTabBarDblClick;
    //~ GetCurrentEditor().onTabClick = tabClicking.onTabClick;
    //~ GetCurrentEditor().mTabContainer.setAttribute('ondblclick', 'tabClicking.onTabBarDblClick(event);');
    if (window.tablib) tablib.init();
alert("loaded!");
  },

  onTabClick: function(evt) {
    var eCtrlKey = (((evt.ctrlKey)||(evt.metaKey)) && (!evt.altKey) && (!evt.shiftKey));
    var eAltKey = ((!(evt.ctrlKey)||(evt.metaKey)) && (evt.altKey) && (!evt.shiftKey));
    var eShiftKey = ((!(evt.ctrlKey)||(evt.metaKey)) && (!evt.altKey) && (evt.shiftKey));

    // don't do anything when the tabs close buttun is clicked
    if ((evt.originalTarget.localName == 'toolbarbutton')
        && (evt.originalTarget.getAttribute('class').indexOf('tabs-closebutton') !=  -1))
      return;

    var eTabClicked = false, evtTarget = evt.originalTarget;
    while (evtTarget.localName != 'tabs') {
      eTabClicked = (evtTarget.localName == 'tab')
      if (eTabClicked)
        break;
      evtTarget = evtTarget.parentNode;
    }

      /* load preferences for tab click */
    var actionNum = tabClicking.tcPrefs.getCharPref("extensions.tabclicking.action");
    var selectTabNum = tabClicking.tcPrefs.getCharPref("extensions.tabclicking.select_new_tab");

    if ((tabClicking.tcPrefs.getBoolPref("middlemouse.contentLoadURL")) && (evt.button == 1))
      return;
    else if (eTabClicked) { // click on a tab
      // asign selected tab to variable
      var selectedTab = evtTarget;
      if (evt.button == 1) { // middle click on tab
        tabClicking.setTCPrefs(2, actionNum, selectTabNum);
        tabClicking.switchCase(selectedTab, evt); // perform function for this event with preferences loaded
      }
      else if ((evt.button == 0) && (eCtrlKey)) { // ctrl click on tab
        tabClicking.setTCPrefs(4, actionNum, selectTabNum);
        tabClicking.switchCase(selectedTab, evt);
      }
      else if ((evt.button == 0) && (eAltKey)) { // alt click on tab
        tabClicking.setTCPrefs(6, actionNum, selectTabNum);
        tabClicking.switchCase(selectedTab, evt);
      }
      else if ((evt.button == 0) && (eShiftKey)) { // shift click on tab
      tabClicking.setTCPrefs(8, actionNum, selectTabNum);
        tabClicking.switchCase(selectedTab, evt);
      }
    }
    else if (!eTabClicked) { // not clicked on a tab
      // asign current open tab to variable
      var theTab = getBrowser().mCurrentTab;
      if (evt.button == 1) { // middle click on tabbar
        tabClicking.setTCPrefs(3, actionNum, selectTabNum);
        tabClicking.switchCase(theTab, evt);
      }
      else if ((evt.button == 0) && (eCtrlKey)) { // ctrl click on tabbar
        tabClicking.setTCPrefs(5, actionNum, selectTabNum);
        tabClicking.switchCase(theTab, evt);
      }
      else if ((evt.button == 0) && (eAltKey)) { // alt click on tabbar
        tabClicking.setTCPrefs(7, actionNum, selectTabNum);
        tabClicking.switchCase(theTab, evt);
      }
      else if ((evt.button == 0) && (eShiftKey)) { // shift click on tabbar
        tabClicking.setTCPrefs(9, actionNum, selectTabNum);
        tabClicking.switchCase(theTab, evt);
      }
    }
  },

    /* double click function */
  onTabBarDblClick: function(evt) {
    var eTabClicked = false, evtTarget = evt.originalTarget;
    while (evtTarget.localName != 'tabs') {
      eTabClicked = (evtTarget.localName == 'tab')
      if (eTabClicked)
        break;
      evtTarget = evtTarget.parentNode;
    }
    var eNoModifierKey = ((!evt.shiftKey) && (!evt.altKey) && ((!evt.ctrlKey) || (!evt.metaKey)));
    /* load preferences for double clicking */
    var actionNum = tabClicking.tcPrefs.getCharPref("extensions.tabclicking.action");
    var selectTabNum = tabClicking.tcPrefs.getCharPref("extensions.tabclicking.select_new_tab");

     /* check for double-left-clicking on the tabbar, not using alt, ctrl or shift key */
    if ((!eTabClicked) && (evt.button == 0) && eNoModifierKey) {
      // asign currently open tab to variable
      var theTab = getBrowser().mCurrentTab;
      tabClicking.setTCPrefs(1, actionNum, selectTabNum);
      tabClicking.switchCase(theTab, evt);
    }
     /* check for double-left-clicking on a tab, not using alt, ctrl or shift key */
    else if ((eTabClicked) && (evt.button == 0) && eNoModifierKey) {
      // assign tab on which is double clicked to variable
      var dblclickedTab = evtTarget;
      tabClicking.setTCPrefs(0, actionNum, selectTabNum);
      tabClicking.switchCase(dblclickedTab, evt);
    }
  },

  setTCPrefs: function(num1, str1, str2) {
    this.prefs.action = parseInt(str1.charAt(num1), 16);
    var newTabVal = parseInt(str2.charAt(num1))
    this.prefs.selectTab = Boolean(newTabVal%2);
    this.prefs.tablib = ((newTabVal>1) && (getBrowser().moveTabTo != undefined));
  },

  switchCase: function(aTab, evt) {
    switch (tabClicking.prefs.action) {

      // add new tab
      case 1:
        var newTab;

        // compatibility with TabBrowser Preferences
        if (window.TBP_BrowserOpenTabClick != undefined) {
          newTab = TBP_BrowserOpenTabClick(evt);
          var TBPloadhome = tabClicking.tcPrefs.getBoolPref("extensions.tabprefs.loadHome");
          if (!tabClicking.prefs.selectTab && !TBPloadhome)
            getBrowser().selectedTab = aTab;
        }

        else {
          newTab = getBrowser().addTab();
          if (tabClicking.prefs.selectTab) {
            getBrowser().selectedTab = newTab;
            tabClicking.selectURLBar();
          }
        }

        if (tabClicking.prefs.tablib)
          getBrowser().moveTabTo(newTab, aTab._tPos+1);
        break;

      // reload tab
      case 2:
        getBrowser().getBrowserForTab(aTab).reload();
        if (this.prefs.selectTab)
          getBrowser().selectedTab = aTab;
        break;

      // reload all tabs
      case 3:
        getBrowser().reloadAllTabs(aTab);
        break;

      // close tab
      case 4:
        getBrowser().removeTab(aTab);
        evt.stopPropagation();
        break;

      // close other tabs
      case 5:
        getBrowser().removeAllTabsBut(aTab);
        break;

      // Close All Tabs
      case 6:
        tabClicking.closeAllTabs();
        break;

      // duplicate tab
      case 7:
        tabClicking.toBeClonedBrowser = getBrowser().getBrowserForTab(aTab);
        tabClicking.selectedTab = aTab
        tabClicking.duplicateInTab();
        break;

      // duplicate tab to new window
      case 8:
        tabClicking.toBeClonedBrowser = getBrowser().getBrowserForTab(aTab);
        tabClicking.duplicateInWindow();
        break;

      // Undo Remove Tab (UndoCloseTab extension)
      case 9:
        if (getBrowser().undoRemoveTab != undefined)
          getBrowser().undoRemoveTab();
        break;

      // select tab for merging (Duplicate Tab 0.3 and newer)
      case 10:
        if (duplicateTab.selectBrowser != undefined) {
          duplicateTab.selectedTab = aTab;
          duplicateTab.selectBrowser();
        }
        break;

      // Reopen Last Closed Tab (Click2Tab extension)
      case 11:
        if (TabbrowserClick2Tab != undefined)
          TabbrowserClick2Tab.undoLastClosedTab();
        break;

      // View Tab in IE
      case 12:
        if (window.ieViewLaunch != undefined) {
          var href = getBrowser().getBrowserForTab(aTab).currentURI.spec;
          ieViewLaunch("Internet Explorer.lnk", href);
        }
        break;

      // SnapBack Tab (SessionSaver extension)
      case 13:
        if (window.SessionSaver != undefined)
          if (SessionSaver.snapBackTab != undefined)
            SessionSaver.snapBackTab();
        break;

      // Do Nothing
      default:
        break;
    }
  },

  closeAllTabs: function() {
    var tabs = getBrowser().mTabContainer.childNodes
    var l = tabs.length;
    while (l > 1) {
      l--;
      getBrowser().removeTab(tabs[l]);
    }
    if (l == 1) {
      var theBrowser = getBrowser().mCurrentBrowser;
      theBrowser.loadURI('about:blank');
      var sHistory = theBrowser.webNavigation.sessionHistory;
      var sHistoryLength = sHistory.count;
      sHistory.PurgeHistory(sHistoryLength);
      tabClicking.selectURLBar();
    }
  },

  selectURLBar: function() {
    if (!gURLBar) gURLBar = document.getElementById('urlbar');
    if (gURLBar) setTimeout(function() { gURLBar.focus(); }, 0);
  },

    /* duplicate tab funcion */
  duplicateInTab: function() {
		delete this.clonedHistory;
		this.clonedHistory = this.copyTabHistory(this.toBeClonedBrowser.webNavigation.sessionHistory);
		this.scrollPosX = this.toBeClonedBrowser.contentWindow.scrollX;
		this.scrollPosY = this.toBeClonedBrowser.contentWindow.scrollY;
		this.zoomFactor = this.toBeClonedBrowser.markupDocumentViewer.textZoom;

		// Open new tab
		var newTab = getBrowser().addTab();
      // give focus to new tab as desired by user
    if (tabClicking.prefs.selectTab) {
		  getBrowser().selectedTab = newTab;
    }
    if (tabClicking.prefs.tablib) {
      if (newTab._tPos > tabClicking.selectedTab._tPos)
        getBrowser().moveTabTo(newTab, tabClicking.selectedTab._tPos+1);
      else if (newTab._tPos < tabClicking.selectedTab._tPos)
        getBrowser().moveTabTo(newTab, tabClicking.selectedTab._tPos);
    }
		this.openedBrowser = getBrowser().getBrowserForTab(newTab);

		// Clone history to new tab
		this.cloneTabHistory(this.openedBrowser.webNavigation, this.clonedHistory);

		// Restore scroll position and zoom factor
		window.setTimeout(function() {tabClicking.openedBrowser.contentWindow.scrollTo(tabClicking.scrollPosX, tabClicking.scrollPosY);}, 0);
		this.openedBrowser.markupDocumentViewer.textZoom = this.zoomFactor;

		// Select URL bar
		if (gURLBar) window.setTimeout('gURLBar.select();', 100);
	},

	duplicateInWindow: function()
  {
		// Copy current history and scroll position to vars
		delete this.clonedHistory;
		this.clonedHistory = this.copyTabHistory(this.toBeClonedBrowser.webNavigation.sessionHistory);
		this.scrollPosX = this.toBeClonedBrowser.contentWindow.scrollX;
		this.scrollPosY = this.toBeClonedBrowser.contentWindow.scrollY;
		this.zoomFactor = this.toBeClonedBrowser.markupDocumentViewer.textZoom;

		// Open new window
    var chromeURL = tabClicking.tcPrefs.getCharPref("browser.chromeURL");
		this.openedWindow = window.openDialog(chromeURL, '_blank', 'chrome,all,dialog=no');

		// Wait until session history is created in new window
		this.openedWindow.addEventListener('load', function() {tabClicking.waitForSessionHistory(10);}, false);
	},

	waitForSessionHistory: function(attempts)
  {
		// Test if sessionHistory exists yet
		var webNav = this.openedWindow.document.getElementById('content').webNavigation;
		try
		{
			webNav.sessionHistory;
		}
		catch (err)
		{
			// Error occurred, try again later
			if (attempts) window.setTimeout('tabClicking.waitForSessionHistory(' + --attempts + ')', 100);
			return;
		}

		// Clone history to new window
		this.cloneTabHistory(webNav, tabClicking.clonedHistory);

		// Restore scroll position and zoom factor if enabled
		this.openedBrowser = this.openedWindow.document.getElementById('content').mCurrentBrowser;
    window.setTimeout(function() {tabClicking.openedBrowser.contentWindow.scrollTo(tabClicking.scrollPosX, tabClicking.scrollPosY);}, 0);
		this.openedBrowser.markupDocumentViewer.textZoom = this.zoomFactor;
	},

	copyTabHistory: function(originalHistory)
	{
		// Copy passed in history into an array and return it
		var copiedHistory = new Array();
		for (var i = 0; i < originalHistory.count; i++)
		{
			copiedHistory.push(originalHistory.getEntryAtIndex(i, false));
		}
		copiedHistory.index = originalHistory.index;
		return copiedHistory;
	},

	cloneTabHistory: function(webNav, originalHistory)
	{
		// Clone history from var
		var newHistory = webNav.sessionHistory;
		newHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);
		if (newHistory.count > 0) newHistory.PurgeHistory(newHistory.count);
		for (var i = 0; i < originalHistory.length; i++)
		{
			newHistory.addEntry(originalHistory[i], true);
		}

		// Goto current history location
		if (originalHistory.length > 0 && originalHistory.index >= 0)
		{
			webNav.gotoIndex(originalHistory.index);
		}
	}
}

// load onLoad function on browser load
//~ window.addEventListener("load",tabClicking.onLoad,false);
//~ GetCurrentEditor().addEventListener("load",tabClicking.onLoad,false);
//~ window.top.addEventListener("load",tabClicking.onLoad,false);